
class Signal; class Zone; class Aiguille; 

/////////////////////////////////////////////////////////////////////////////

#include "AiguilleEtZone.h"
#include "Signal.h"
#include "Signaux.h"
#include "SignalBAL.h"
#include "SignauxBAL.h"
#include "Itineraire.h"

/////////////////////////////////////////////////////////////////////////////

// les zones reelles, a ecrire par l'utilisateur

class Z8 : public Zone { // héritage de Zone
public:
  Z8(int n):Zone(n) {} // constructeur mini
  Z8(char* nm,int t,int n):Zone(nm,t,n) {} // constructeur maxi
  virtual void actions();
  virtual void desactions();
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

class Z9 : public Zone { // héritage de Zone
public:
  Z9(int n):Zone(n) {} // constructeur mini
  Z9(char* nm,int t,int n):Zone(nm,t,n) {} // constructeur maxi
  virtual void actions();
  virtual void desactions();
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

class Z10 : public Zone { // héritage de Zone
public:
  Z10(int n):Zone(n) {} // constructeur mini
  Z10(char* nm,int t,int n):Zone(nm,t,n) {} // constructeur maxi
  virtual void actions();
  virtual void desactions();
  virtual Zone* suivantePaire();
  virtual Zone* suivanteImpaire();
};

/////////////////////////////////////////////////////////////////////////////
// les signaux reels, a ecrire par l'utilisateur

class A09:public Avertissement { // attention au conflit avec les pins analogiques A0 A1 ...
public:
  A09(int n):Avertissement(n) {} // constructeur mini
  A09(char* nm,int t,int n):Avertissement(nm,t,n) {} // constructeur mini
  virtual Signal* suivant();
};

class C2:public Carre {
public:
  C2(int n):Carre(n) {} // constructeur mini
  C2(char* nm,int t,int n):Carre(nm,t,n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
};

class C3:public CarreRappelRalentissement {
public:
  C3(int n):CarreRappelRalentissement(n) {} // constructeur mini
  C3(char* nm,int t,int n):CarreRappelRalentissement(nm,t,n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
  virtual boolean ralentissement30();
};

class S5:public SemaphoreBALRalentissement {
public:
  S5(int n):SemaphoreBALRalentissement(n) {} // constructeur mini
  S5(char* nm,int t,int n):SemaphoreBALRalentissement(nm,t,n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
  virtual boolean cantonOccupe();
};

class C6:public CarreBALRappelRalentissement {
public:
  C6(int n):CarreBALRappelRalentissement(n) {} // constructeur mini
  C6(char* nm,int t,int n):CarreBALRappelRalentissement(nm,t,n) {} // constructeur mini
  virtual Signal* suivant();
  virtual Signal* precedent();
  virtual boolean cantonOccupe();
  virtual boolean ralentissement60();
  virtual boolean ralentissement30();
};

/////////////////////////////////////////////////////////////////////////////
// declarations, a ecrire par l'utilisateur

Signal* cv3=new CarreViolet("Cv3",BAS,1); // instanciation directe
Signal* a9=new A09("A9",MECANIQUE,11); // signaux
Signal* c2=new C2(3); 
Signal* c3=new C3(5); // signaux
SignalBAL* s5=new S5("S5",BAL,3); 
Signal* c6=new C6(5); // signaux

Zone* z8=new Z8(5); Zone* z9=new Z9("Z9",SENS_IMPAIR_OU_PAIR,7); Zone* z10=new Z10(3); // zones

Zone* const tableZones[] {z8,z9,z10}; // la table des zones pour la retrosignalisation

Aiguille* aig1=new Aiguille(1); Aiguille* aig2=new Aiguille(2); Aiguille* aig3=new Aiguille(7); // aiguilles

Itineraire* iTC=new Itineraire(); Itineraire* iCT=new Itineraire(); // itineraires

/////////////////////////////////////////////////////////////////////////////
// les methodes des zones, a ecrire par l'utilisateur

void Z8::actions() { c2->aubiner(); }
void Z8::desactions() {}
Zone* Z8::suivantePaire() { return z10; }
Zone* Z8::suivanteImpaire() { return z9; }

void Z9::actions() {}
void Z9::desactions() { s5->desaubiner(); }
Zone* Z9::suivantePaire() { return z8; }
Zone* Z9::suivanteImpaire() { return NULL; }

void Z10::actions() {}
void Z10::desactions() { iTC->detruire(); }
Zone* Z10::suivantePaire() { return z8; }
Zone* Z10::suivanteImpaire() { return selonAiguille(aig1,z8,z9); }

/////////////////////////////////////////////////////////////////////////////
// les methodes des signaux, a ecrire par l'utilisateur

Signal* A09::suivant() { return c2; }

Signal* C2::suivant() { return c3; }
Signal* C2::precedent() { return a9; }

Signal* C3::suivant() { return c3; } 
Signal* C3::precedent() { return c2; }
boolean C3:: ralentissement30() { return true; }
  
Signal* S5::suivant() { return c3; } 
Signal* S5::precedent() { return c2; }
boolean S5::cantonOccupe() { return occupees(z8,z9); }

Signal* C6::suivant() { return selonAiguille(aig2,c2,c3); } // selon aig2
Signal* C6::precedent() { return c2; }
boolean C6::cantonOccupe() { if (aig1->directe()) return occupee(z10); return occupees(z8,z9); } // canton dynamique
boolean C6::ralentissement60() { return aig1->deviee(); }
boolean C6::ralentissement30() { return aig1->directe() && aig2->deviee(); }
    
/////////////////////////////////////////////////////////////////////////////

void setup() {
  // put your setup code here, to run once:
}

void loop() {
  // put your main code here, to run repeatedly:
}
